# Class VulkanPipelineInputAssemblyStateCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineInputAssemblyStateCreateInfo

All Implemented Interfaces:
  `VulkanPipelineInputAssemblyStateCreateInfoType`

public final class VulkanPipelineInputAssemblyStateCreateInfo extends Object implements VulkanPipelineInputAssemblyStateCreateInfoType

See Also:
  - "VkPipelineInputAssemblyStateCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineInputAssemblyStateCreateInfo.Builder`
  Builds instances of type `VulkanPipelineInputAssemblyStateCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineInputAssemblyStateCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineInputAssemblyStateCreateInfo`.
  `static VulkanPipelineInputAssemblyStateCreateInfo`
  `copyOf(VulkanPipelineInputAssemblyStateCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineInputAssemblyStateCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineInputAssemblyStateCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineInputAssemblyStateCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `topology`, `primitiveRestartEnable`.
  `static VulkanPipelineInputAssemblyStateCreateInfo`
  `of(Iterable<VulkanPipelineInputAssemblyStateCreateFlag> flags, VulkanPrimitiveTopology topology, boolean primitiveRestartEnable)`
  Construct a new immutable `VulkanPipelineInputAssemblyStateCreateInfo` instance.
  `static VulkanPipelineInputAssemblyStateCreateInfo`
  `of(Set<VulkanPipelineInputAssemblyStateCreateFlag> flags, VulkanPrimitiveTopology topology, boolean primitiveRestartEnable)`
  Construct a new immutable `VulkanPipelineInputAssemblyStateCreateInfo` instance.
  `boolean`
  `primitiveRestartEnable()`
  `VulkanPrimitiveTopology`
  `topology()`
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineInputAssemblyStateCreateInfo` with attribute values.
  `final VulkanPipelineInputAssemblyStateCreateInfo`
  `withFlags(VulkanPipelineInputAssemblyStateCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineInputAssemblyStateCreateInfo`
  `withFlags(Iterable<VulkanPipelineInputAssemblyStateCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineInputAssemblyStateCreateInfo`
  `withPrimitiveRestartEnable(boolean value)`
  Copy the current immutable object by setting a value for the `primitiveRestartEnable` attribute.
  `final VulkanPipelineInputAssemblyStateCreateInfo`
  `withTopology(VulkanPrimitiveTopology value)`
  Copy the current immutable object by setting a value for the `topology` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineInputAssemblyStateCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineInputAssemblyStateCreateInfoType`
    Returns:
      Flags reserved for future use

  - ### topology

    public VulkanPrimitiveTopology topology()
    Specified by:
      `topology` in interface `VulkanPipelineInputAssemblyStateCreateInfoType`
    Returns:
      The primitive topology

  - ### primitiveRestartEnable

    public boolean primitiveRestartEnable()
    Specified by:
      `primitiveRestartEnable` in interface `VulkanPipelineInputAssemblyStateCreateInfoType`
    Returns:
      `true` if a special vertex index value is treated as restarting the assembly of primitives

  - ### withFlags

    public final VulkanPipelineInputAssemblyStateCreateInfo withFlags(VulkanPipelineInputAssemblyStateCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineInputAssemblyStateCreateInfo withFlags(Iterable<VulkanPipelineInputAssemblyStateCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withTopology

    public final VulkanPipelineInputAssemblyStateCreateInfo withTopology(VulkanPrimitiveTopology value)
    Copy the current immutable object by setting a value for the `topology` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for topology
    Returns:
      A modified copy of the `this` object

  - ### withPrimitiveRestartEnable

    public final VulkanPipelineInputAssemblyStateCreateInfo withPrimitiveRestartEnable(boolean value)
    Copy the current immutable object by setting a value for the `primitiveRestartEnable` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for primitiveRestartEnable
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineInputAssemblyStateCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `topology`, `primitiveRestartEnable`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineInputAssemblyStateCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineInputAssemblyStateCreateInfo of(Set<VulkanPipelineInputAssemblyStateCreateFlag> flags, VulkanPrimitiveTopology topology, boolean primitiveRestartEnable)
    Construct a new immutable `VulkanPipelineInputAssemblyStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `topology` - The value for the `topology` attribute
      `primitiveRestartEnable` - The value for the `primitiveRestartEnable` attribute
    Returns:
      An immutable VulkanPipelineInputAssemblyStateCreateInfo instance

  - ### of

    public static VulkanPipelineInputAssemblyStateCreateInfo of(Iterable<VulkanPipelineInputAssemblyStateCreateFlag> flags, VulkanPrimitiveTopology topology, boolean primitiveRestartEnable)
    Construct a new immutable `VulkanPipelineInputAssemblyStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `topology` - The value for the `topology` attribute
      `primitiveRestartEnable` - The value for the `primitiveRestartEnable` attribute
    Returns:
      An immutable VulkanPipelineInputAssemblyStateCreateInfo instance

  - ### copyOf

    public static VulkanPipelineInputAssemblyStateCreateInfo copyOf(VulkanPipelineInputAssemblyStateCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineInputAssemblyStateCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineInputAssemblyStateCreateInfo instance

  - ### builder

    public static VulkanPipelineInputAssemblyStateCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineInputAssemblyStateCreateInfo`.

         VulkanPipelineInputAssemblyStateCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineInputAssemblyStateCreateFlag) // flags elements
            .setTopology(com.io7m.jcoronado.api.VulkanPrimitiveTopology) // required topology
            .setPrimitiveRestartEnable(boolean) // required primitiveRestartEnable
            .build();

    Returns:
      A new VulkanPipelineInputAssemblyStateCreateInfo builder